# Copyright (c) 2000-2012, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define section free
%define _binary_payload w9.gzdio
%define _source_payload w9.gzdio
%define _binary_filedigest_algorithm 1
%define _source_filedigest_algorithm 1

Name:           gossip
Version:        1.8
Release:        2%{?dist}
Epoch:          0
Summary:        Gossip
License:        ASL 2.0
URL:            http://gossip.fusesource.org
Group:          Development/Libraries/Java
# git clone git://github.com/jdillon/gossip.git
# cd gossip/
# git tag -l
# git archive gossip-1.8 > ../SOURCES/gossip-1.8.tar
# gzip ../SOURCES/gossip-1.8.tar

Source0:        gossip-1.8.tar.gz
Source1:        %{name}-settings.xml
Source2:        %{name}-jpp-depmap.xml
Patch0:         gossip-core-Configurator.patch
Patch1:         gossip-core-EffectiveProfile.patch
Patch2:         gossip-core-gossip-mdo.patch
Requires(post): jpackage-utils >= 0:1.7.5
Requires(postun): jpackage-utils >= 0:1.7.5
Requires:       jpackage-utils >= 0:1.7.5
BuildRequires:  maven2 >= 0:2.0.8
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-source
BuildRequires:  maven-skins
BuildRequires:  maven-license-plugin
BuildRequires:  maven-plugin-modello
BuildRequires:  maven-release
BuildRequires:  maven-surefire-plugin
BuildRequires:  maven-surefire-provider-junit4
BuildRequires:  mojo-maven2-plugin-cobertura
BuildRequires:  mojo-maven2-plugin-findbugs
BuildRequires:  mojo-parent
BuildRequires:  mojo-signatures
BuildRequires:  animal-sniffer
BuildRequires:  gmaven
BuildRequires:  gmaven-runtime-1.5
BuildRequires:  groovy16
BuildRequires:  jansi >= 0:1.5
BuildRequires:  junit4
BuildRequires:  slf4j
BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root
Requires:  slf4j

%description
Gossip is a plugin for SLF4j which has simple and flexible 
configuration.

%package devel
Summary:        Source archives for %{name}
Group:          Development/Libraries/Java

%description devel
%{summary}.

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation
Requires:       jpackage-utils

%description javadoc
%{summary}.

%package manual
Summary:        Documents for %{name}
Group:          Development/Documentation

%description manual
%{summary}.

%prep
%setup -q -c
%patch0 -p0 -b .sav0
%patch1 -p0 -b .sav1
%patch2 -p0 -b .sav2
cp %{SOURCE1} settings.xml

%build
sed -i -e "s|<url>__JPP_URL_PLACEHOLDER__</url>|<url>file://`pwd`/.m2/repository</url>|g" settings.xml
sed -i -e "s|<url>__JAVADIR_PLACEHOLDER__</url>|<url>file://`pwd`/external_repo</url>|g" settings.xml
sed -i -e "s|<url>__MAVENREPO_DIR_PLACEHOLDER__</url>|<url>file://`pwd`/.m2/repository</url>|g" settings.xml

export MAVEN_REPO_LOCAL=$(pwd)/.m2/repository

mkdir external_repo
ln -s %{_javadir} external_repo/JPP

export SETTINGS=$(pwd)/settings.xml

%{_bindir}/mvn-jpp \
        -e \
        -s $SETTINGS \
        -Dmaven2.jpp.depmap.file=%{SOURCE2} \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        -Dgmaven.runtime=1.6 \
        install \
        javadoc:aggregate \
        site

#        -Dmaven.test.skip=true \

%install
rm -rf %{buildroot}

install -d -m 0755 %{buildroot}%{_javadir}/%{name}/sources

install -m 0644 gossip-bootstrap-slf4j/target/gossip-bootstrap-slf4j-%{version}.jar %{buildroot}%{_javadir}/%{name}
install -m 0644 gossip-bootstrap-slf4j/target/gossip-bootstrap-slf4j-%{version}-sources.jar %{buildroot}%{_javadir}/%{name}/sources/gossip-bootstrap-slf4j-sources-%{version}.jar
install -m 0644 gossip-bootstrap/target/gossip-bootstrap-%{version}.jar %{buildroot}%{_javadir}/%{name}
install -m 0644 gossip-bootstrap/target/gossip-bootstrap-%{version}-sources.jar %{buildroot}%{_javadir}/%{name}/sources/gossip-bootstrap-sources-%{version}.jar
install -m 0644 gossip-core/target/gossip-core-%{version}.jar %{buildroot}%{_javadir}/%{name}
install -m 0644 gossip-core/target/gossip-core-%{version}-sources.jar %{buildroot}%{_javadir}/%{name}/sources/gossip-core-sources-%{version}.jar
install -m 0644 gossip-extra/target/gossip-extra-%{version}.jar %{buildroot}%{_javadir}/%{name}
install -m 0644 gossip-extra/target/gossip-extra-%{version}-sources.jar %{buildroot}%{_javadir}/%{name}/sources/gossip-extra-sources-%{version}.jar
install -m 0644 gossip-slf4j/target/gossip-slf4j-%{version}.jar %{buildroot}%{_javadir}/%{name}
install -m 0644 gossip-slf4j/target/gossip-slf4j-%{version}-sources.jar %{buildroot}%{_javadir}/%{name}/sources/gossip-slf4j-sources-%{version}.jar
install -m 0644 gossip-support/target/gossip-support-%{version}.jar %{buildroot}%{_javadir}/%{name}
install -m 0644 gossip-support/target/gossip-support-%{version}-sources.jar %{buildroot}%{_javadir}/%{name}/sources/gossip-support-sources-%{version}.jar
(cd %{buildroot}%{_javadir}/%{name}/sources && for jar in *-%{version}*; do ln -s ${jar} ${jar/-%{version}/}; done)
(cd %{buildroot}%{_javadir}/%{name} && for jar in *-%{version}*; do ln -s ${jar} ${jar/-%{version}/}; done)
(cd %{buildroot}%{_javadir} && ln -s %{name}/%{name}-core.jar && ln -s %{name}/%{name}-slf4j.jar)

install -d -m 755 %{buildroot}%{_datadir}/maven2/poms
install -m 0644 pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP-gossip.pom
install -m 0644 gossip-bootstrap-slf4j/pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP.gossip-gossip-bootstrap-slf4j.pom
install -m 0644 gossip-bootstrap/pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP.gossip-gossip-bootstrap.pom
install -m 0644 gossip-core/pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP.gossip-gossip-core.pom
install -m 0644 gossip-extra/pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP.gossip-gossip-extra.pom
install -m 0644 gossip-slf4j/pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP.gossip-gossip-slf4j.pom
install -m 0644 gossip-support/pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP.gossip-gossip-support.pom

install -m 0644 gossip-core/pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP-gossip-core.pom
install -m 0644 gossip-slf4j/pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP-gossip-slf4j.pom

%add_to_maven_depmap org.sonatype.gossip gossip %{version} JPP gossip
%add_to_maven_depmap org.sonatype.gossip gossip-bootstrap-slf4j %{version} JPP/gossip gossip-bootstrap-slf4j
%add_to_maven_depmap org.sonatype.gossip gossip-bootstrap %{version} JPP/gossip gossip-bootstrap
%add_to_maven_depmap org.sonatype.gossip gossip-core %{version} JPP/gossip gossip-core
%add_to_maven_depmap org.sonatype.gossip gossip-extra %{version} JPP/gossip gossip-extra
%add_to_maven_depmap org.sonatype.gossip gossip-slf4j %{version} JPP/gossip gossip-slf4j
%add_to_maven_depmap org.sonatype.gossip gossip-support %{version} JPP/gossip gossip-support

%add_to_maven_depmap org.sonatype.gossip gossip-core %{version} JPP gossip-core
%add_to_maven_depmap org.sonatype.gossip gossip-slf4j %{version} JPP gossip-slf4j

# javadoc
mkdir -p %{buildroot}%{_javadocdir}/%{name}-%{version}
cp -pr target/site/apidocs/* %{buildroot}%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} %{buildroot}%{_javadocdir}/%{name}

# manual
mkdir -p %{buildroot}%{_docdir}/%{name}-%{version}
cp -pr target/site/* %{buildroot}%{_docdir}/%{name}-%{version}
rm -r %{buildroot}%{_docdir}/%{name}-%{version}/apidocs

%clean
rm -rf %{buildroot}

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(0644,root,root,0755)
%doc README.md
%dir %{_javadir}/%{name}
%{_javadir}/%{name}/*.jar
%{_javadir}/*.jar
%{_datadir}/maven2/poms/*
%{_mavendepmapfragdir}/*

%files devel
%defattr(0644,root,root,0755)
%dir %{_javadir}/%{name}/sources
%{_javadir}/%{name}/sources/*.jar

%files javadoc
%defattr(0644,root,root,0755)
%doc %{_javadocdir}/*

%files manual
%defattr(0644,root,root,0755)
%doc %{_docdir}/%{name}-%{version}

%changelog
* Sun Jun 17 2012 Ralph Apel <r.apel@r-apel.de> 0:1.8-2
- Avoid FileDigest and PayloadIsXz problems on EL5

* Fri Feb 17 2012 Ralph Apel <r.apel@r-apel.de> 0:1.8-1
- 1.8

* Tue Dec 21 2010 David Walluck <dwalluck@redhat.com> 0:1.5-1
- release
